// くま大戦
enchant();
var game, bear, enemy;
var walk = [0, 1, 0, 2];
var walkidx = 0;
var enemies = new Group();
window.onload = function() {
    game = new Game(320, 320);
    game.preload("chara1.gif");
    game.rootScene.addChild(enemies);
    game.rootScene.backgroundColor = "#AFA";
    game.onload = function() {
        showPlayer();
        game.rootScene.addEventListener("enterframe", function() {
            if (game.frame % 4 == 0) anime();
            movePlayer();
            if (game.frame % 12 == 0) showEnemy();
            for (var i = 0; i < enemies.childNodes.length; ++i) {
                enemy = enemies.childNodes[i];
                moveEnemy();
                if (enemy.y > 300) enemies.removeChild(enemy);
            }
        });
    }
    game.start();
}

function showPlayer() {
    bear = new Sprite(32, 32);
    bear.image = game.assets["chara1.gif"];
    bear.frame = 0;
    bear.x = 160;
    bear.y = 200;
    game.rootScene.addChild(bear);
}

function anime() {
    if (++walkidx == walk.length) walkidx = 0;
    bear.frame = walk[walkidx];
}

function movePlayer() {
    if (game.input.left && bear.x > 0) {
        bear.x -= 10;
        bear.scaleX = -1;
    }
    if (game.input.right && bear.x < 320 - 32) {
        bear.x += 10;
        bear.scaleX = 1;
    }
}

function showEnemy() {
    enemy = new Sprite(32, 32);
    enemy.image = game.assets["chara1.gif"];
    enemy.frame = 5;
    enemy.x = (320 - 32) * Math.random();
    enemy.y = 0;
    enemies.addChild(enemy);
}

function moveEnemy() {
    enemy.y += 3;
    if (enemy.y > 230) {
        enemy.frame = 8;
    } else {
        if (Math.random() < 0.2) {
            if (enemy.x > bear.x) {
                enemy.x -= 3;
                enemy.scaleX = -1;
            } else {
                enemy.x += 3;
                enemy.scaleX = 1;
            }
        }
        if (enemy.within(bear, 15)) gameover();
    }
}

function gameover() {
    var label = new Label("GAME OVER<br/>SCORE:" + game.frame);
    label.color = "red";
    label.font = "20px cursive";
    label.x = 100;
    label.y = 150;
    game.rootScene.addChild(label);
    game.stop();
}
